<template>
  <div>
    <div class="email-form" v-show="!validated">
      <butter-text-field
      label="Email"
      type="email"
      placeholder="name@email.com"
      :error="emailError"
      :name="name"
      @blur="validateEmail"
      @input="input"
      v-model="email" />
      <confirmation-code v-show="confirming" ref="validator" v-model="code" />
      <p v-if="confirming">Don't see an email? <a @click="send" v-if="!resending">Resend</a><span v-else>Sent!</span></p>
      <div class="actions">
        <butter-button v-if="verify && !confirming" @click="send" :disabled="!email || !emailValid">Verify Email</butter-button>
        <butter-button v-else-if="verify" @click="confirm" :disabled="!code || !codeValid">Submit Code</butter-button>
      </div>
    </div>
    <div class="validated-email" v-show="validated">
      <butter-text-field
        label="Email Verified"
        type="text"
        placeholder="name@email.com"
        :disabled="true"
        name="verified"
        :value="email" />
    </div>
  </div>
</template>
<style lang="scss" scoped>
@import 'butter-mixins';
p {
  padding: 0 $grid;
}
.email, .confirmation-code {
  position: relative;

  @include form-field;

  .icon {
    color: green;
    position: absolute;
    display: block;

    right: $grid*0.25;
    bottom: $grid*0.25;

    height: $grid;
    width: $grid;
  }
}
.confirmation-code {
  .send {
    position: absolute;

    right: 0;
    top: 0;
    bottom: 0;

    display: flex;
    align-items: center;
  }
}
.success {
  text-align: center;
}
.actions {
  padding: $grid;
}
</style>
<script>
import { EVENT_DONE , EVENT_INPUT } from '../lib/events'

const emailValidation = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/

export default {
  props: {
    'name': { type: String },
    'placeholder': { type: String },
    'label': { type: String },
    'verify': { type: Boolean },
    'value': {
      type: String,
      default: "",
    },
    'definition': {},
    'analyticsPrefix': { type: String, required: false, 'default': 'fields.email.' },
    'analyticsArgs': { type: Object, required: false },
    'validated': {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      invalidEmail: false,
      confirming: false,
      email: this.value,
      code: null,
      resending: false,
    }
  },
  computed: {
    emailValid() {
      return this.email.match(/.*?@.+?\..+?/);
    },
    codeValid() {
      return this.code && this.code.replace(/\s+/g,'').length == 6;
    },
    emailError() {
      if(this.invalidEmail) {
        return "Please enter a valid email address";
      } else if (this.yahooEmail) {
        return "We’re having some difficulty verifying yahoo addresses, so we recommend an alternative.";
      }
    },
  },
  methods: {
    validateEmail() {
      (this.email != "null" && !emailValidation.test(this.email)) ? this.invalidEmail = true : this.invalidEmail = false;
    },
    present(formValue) {
      if(!formValue) return false;
      if(formValue.email) return true;
      return false;
    },
    valid(formValue) {
      if(!formValue) return false;
      if(!formValue.email) return false;
      if(!formValue.hash) return false;

      return true;
    },

    kvFieldName() {
      return 'email';
    },
    toForm() {
      var email = this.email;
      if(email) {
        return { email: email, hash: email };
      } else {
        return null;
      }
    },
    fromForm(hash) {
      if(typeof hash == 'string') {
        this.email = hash;
        this.confirmed = true;
      } else if(hash && hash.email) {
        this.email = hash.email;
        this.confirmed = true;
      }
    },
    input(e) {
      this.$emit(EVENT_INPUT, this.email);
    },
    async send() {
      this.confirmed = false;
      this.$emit('validate', { action: 'send', value: { email: this.email } });
      this.confirming = true;
      this.resend = true;
      this.$nextTick(() => {
        this.$refs.validator.focus();
      });
    },
    async confirm() {
      this.$emit('validate', { action: 'confirm', value: { code: this.code, email: this.email } });
      this.$emit(EVENT_DONE);
    },
  }

}

</script>
